---
# here for reference, as they are defined at group level
# variables:
# AWS_ACCOUNT_ID: ''
# AWS_ACCESS_KEY_ID: ''
# AWS_SECRET_ACCESS_KEY: ''
# AWS_DEFAULT_REGION: ''
# CDN_BUCKET_NAME: 'justbytes-cdn'

stages:
  - 'build-docker-images'
  - 'push-to-ecr'

build:
  stage: 'build-docker-images'
  rules:
    - if: '$CI_COMMIT_TAG'
      when: 'always'
  image: 'docker:19.03.12'
  tags:
    - 'gitlab-org-docker'
  services:
    - name: 'docker:19.03.12-dind'
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  script:
    - 'docker info'
    - 'docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY'
    - 'docker pull $CI_REGISTRY_IMAGE:latest || true'
    - 'docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG --tag $CI_REGISTRY_IMAGE:latest .'
    - 'docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
    - 'docker push $CI_REGISTRY_IMAGE:latest'

push:
  needs: ['build']
  stage: 'push-to-ecr'
  rules:
    - if: '$CI_COMMIT_TAG'
      when: 'always'
  image: 'registry.gitlab.com/treuzedev/aws-dind:0.1.1'
  services:
    - 'docker:dind'
  variables:
    DOCKER_HOST: 'tcp://docker:2375/'
    DOCKER_DRIVER: 'overlay'
    ECR_REPO: 'kubectl-runtime'
  tags:
    - 'gitlab-org-docker'
  script:
    - 'docker info'
    - 'docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY'
    - 'docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
    - 'docker logout'
    - 'aws --version'
    - 'aws --region eu-west-1 ecr get-login-password | docker login --username AWS --password-stdin $AWS_ACCOUNT_ID.dkr.ecr.eu-west-1.amazonaws.com'
    - 'aws ecr create-repository --repository-name $ECR_REPO --image-scanning-configuration scanOnPush=true || true'
    - 'docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG $AWS_ACCOUNT_ID.dkr.ecr.eu-west-1.amazonaws.com/$ECR_REPO:latest'
    - 'docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG $AWS_ACCOUNT_ID.dkr.ecr.eu-west-1.amazonaws.com/$ECR_REPO:$CI_COMMIT_TAG'
    - 'docker push $AWS_ACCOUNT_ID.dkr.ecr.eu-west-1.amazonaws.com/$ECR_REPO:latest'
    - 'docker push $AWS_ACCOUNT_ID.dkr.ecr.eu-west-1.amazonaws.com/$ECR_REPO:$CI_COMMIT_TAG'
